// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_MEDIA_GALLERY_UTIL_PUBLIC_MOJOM_MEDIA_PARSER_MOJOM_SHARED_H_
#define CHROME_SERVICES_MEDIA_GALLERY_UTIL_PUBLIC_MOJOM_MEDIA_PARSER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/services/media_gallery_util/public/mojom/media_parser.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared.h"
#include "mojo/public/mojom/base/file.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace chrome {
namespace mojom {
class AttachedImageDataView;



}  // namespace mojom
}  // namespace chrome

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::chrome::mojom::AttachedImageDataView> {
  using Data = ::chrome::mojom::internal::AttachedImage_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace chrome {
namespace mojom {
// Interface base classes. They are used for type safety check.
class MediaParserInterfaceBase {};

using MediaParserPtrDataView =
    mojo::InterfacePtrDataView<MediaParserInterfaceBase>;
using MediaParserRequestDataView =
    mojo::InterfaceRequestDataView<MediaParserInterfaceBase>;
using MediaParserAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaParserInterfaceBase>;
using MediaParserAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaParserInterfaceBase>;
class MediaParserFactoryInterfaceBase {};

using MediaParserFactoryPtrDataView =
    mojo::InterfacePtrDataView<MediaParserFactoryInterfaceBase>;
using MediaParserFactoryRequestDataView =
    mojo::InterfaceRequestDataView<MediaParserFactoryInterfaceBase>;
using MediaParserFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaParserFactoryInterfaceBase>;
using MediaParserFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaParserFactoryInterfaceBase>;
class MediaDataSourceInterfaceBase {};

using MediaDataSourcePtrDataView =
    mojo::InterfacePtrDataView<MediaDataSourceInterfaceBase>;
using MediaDataSourceRequestDataView =
    mojo::InterfaceRequestDataView<MediaDataSourceInterfaceBase>;
using MediaDataSourceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MediaDataSourceInterfaceBase>;
using MediaDataSourceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MediaDataSourceInterfaceBase>;
class AttachedImageDataView {
 public:
  AttachedImageDataView() {}

  AttachedImageDataView(
      internal::AttachedImage_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTypeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) {
    auto* pointer = data_->type.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDataDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::AttachedImage_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaParser_ParseMediaMetadata_ParamsDataView {
 public:
  MediaParser_ParseMediaMetadata_ParamsDataView() {}

  MediaParser_ParseMediaMetadata_ParamsDataView(
      internal::MediaParser_ParseMediaMetadata_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMimeTypeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMimeType(UserType* output) {
    auto* pointer = data_->mime_type.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  int64_t total_size() const {
    return data_->total_size;
  }
  bool get_attached_images() const {
    return data_->get_attached_images;
  }
  template <typename UserType>
  UserType TakeMediaDataSource() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::chrome::mojom::MediaDataSourcePtrDataView>(
            &data_->media_data_source, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MediaParser_ParseMediaMetadata_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaParser_ParseMediaMetadata_ResponseParamsDataView {
 public:
  MediaParser_ParseMediaMetadata_ResponseParamsDataView() {}

  MediaParser_ParseMediaMetadata_ResponseParamsDataView(
      internal::MediaParser_ParseMediaMetadata_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool parse_success() const {
    return data_->parse_success;
  }
  inline void GetMetadataDataView(
      ::mojo::common::mojom::DictionaryValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMetadata(UserType* output) {
    auto* pointer = data_->metadata.Get();
    return mojo::internal::Deserialize<::mojo::common::mojom::DictionaryValueDataView>(
        pointer, output, context_);
  }
  inline void GetAttachedImagesDataView(
      mojo::ArrayDataView<AttachedImageDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAttachedImages(UserType* output) {
    auto* pointer = data_->attached_images.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::chrome::mojom::AttachedImageDataView>>(
        pointer, output, context_);
  }
 private:
  internal::MediaParser_ParseMediaMetadata_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaParser_CheckMediaFile_ParamsDataView {
 public:
  MediaParser_CheckMediaFile_ParamsDataView() {}

  MediaParser_CheckMediaFile_ParamsDataView(
      internal::MediaParser_CheckMediaFile_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDecodeTimeDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDecodeTime(UserType* output) {
    auto* pointer = data_->decode_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  inline void GetFileDataView(
      ::mojo_base::mojom::FileDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFile(UserType* output) {
    auto* pointer = data_->file.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FileDataView>(
        pointer, output, context_);
  }
 private:
  internal::MediaParser_CheckMediaFile_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaParser_CheckMediaFile_ResponseParamsDataView {
 public:
  MediaParser_CheckMediaFile_ResponseParamsDataView() {}

  MediaParser_CheckMediaFile_ResponseParamsDataView(
      internal::MediaParser_CheckMediaFile_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::MediaParser_CheckMediaFile_ResponseParams_Data* data_ = nullptr;
};

class MediaParser_GetCpuInfo_ParamsDataView {
 public:
  MediaParser_GetCpuInfo_ParamsDataView() {}

  MediaParser_GetCpuInfo_ParamsDataView(
      internal::MediaParser_GetCpuInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MediaParser_GetCpuInfo_Params_Data* data_ = nullptr;
};

class MediaParser_GetCpuInfo_ResponseParamsDataView {
 public:
  MediaParser_GetCpuInfo_ResponseParamsDataView() {}

  MediaParser_GetCpuInfo_ResponseParamsDataView(
      internal::MediaParser_GetCpuInfo_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t libyuv_cpu_flags() const {
    return data_->libyuv_cpu_flags;
  }
  int64_t ffmpeg_cpu_flags() const {
    return data_->ffmpeg_cpu_flags;
  }
 private:
  internal::MediaParser_GetCpuInfo_ResponseParams_Data* data_ = nullptr;
};

class MediaParserFactory_CreateMediaParser_ParamsDataView {
 public:
  MediaParserFactory_CreateMediaParser_ParamsDataView() {}

  MediaParserFactory_CreateMediaParser_ParamsDataView(
      internal::MediaParserFactory_CreateMediaParser_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t libyuv_cpu_flags() const {
    return data_->libyuv_cpu_flags;
  }
  int64_t libavutil_cpu_flags() const {
    return data_->libavutil_cpu_flags;
  }
 private:
  internal::MediaParserFactory_CreateMediaParser_Params_Data* data_ = nullptr;
};

class MediaParserFactory_CreateMediaParser_ResponseParamsDataView {
 public:
  MediaParserFactory_CreateMediaParser_ResponseParamsDataView() {}

  MediaParserFactory_CreateMediaParser_ResponseParamsDataView(
      internal::MediaParserFactory_CreateMediaParser_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeMediaParser() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::chrome::mojom::MediaParserPtrDataView>(
            &data_->media_parser, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MediaParserFactory_CreateMediaParser_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MediaDataSource_ReadBlob_ParamsDataView {
 public:
  MediaDataSource_ReadBlob_ParamsDataView() {}

  MediaDataSource_ReadBlob_ParamsDataView(
      internal::MediaDataSource_ReadBlob_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t position() const {
    return data_->position;
  }
  int64_t length() const {
    return data_->length;
  }
 private:
  internal::MediaDataSource_ReadBlob_Params_Data* data_ = nullptr;
};

class MediaDataSource_ReadBlob_ResponseParamsDataView {
 public:
  MediaDataSource_ReadBlob_ResponseParamsDataView() {}

  MediaDataSource_ReadBlob_ResponseParamsDataView(
      internal::MediaDataSource_ReadBlob_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::MediaDataSource_ReadBlob_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace chrome

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::chrome::mojom::AttachedImageDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::chrome::mojom::AttachedImageDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::chrome::mojom::internal::AttachedImage_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::type, input, custom_context)) in_type = CallWithContext(Traits::type, input, custom_context);
    typename decltype((*output)->type)::BaseType::BufferWriter
        type_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_type, buffer, &type_writer, context);
    (*output)->type.Set(
        type_writer.is_null() ? nullptr : type_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->type.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null type in AttachedImage struct");
    decltype(CallWithContext(Traits::data, input, custom_context)) in_data = CallWithContext(Traits::data, input, custom_context);
    typename decltype((*output)->data)::BaseType::BufferWriter
        data_writer;
    const mojo::internal::ContainerValidateParams data_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
        in_data, buffer, &data_writer, &data_validate_params,
        context);
    (*output)->data.Set(
        data_writer.is_null() ? nullptr : data_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null data in AttachedImage struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::chrome::mojom::internal::AttachedImage_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::chrome::mojom::AttachedImageDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace chrome {
namespace mojom {

inline void AttachedImageDataView::GetTypeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->type.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void AttachedImageDataView::GetDataDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void MediaParser_ParseMediaMetadata_ParamsDataView::GetMimeTypeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->mime_type.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void MediaParser_ParseMediaMetadata_ResponseParamsDataView::GetMetadataDataView(
    ::mojo::common::mojom::DictionaryValueDataView* output) {
  auto pointer = data_->metadata.Get();
  *output = ::mojo::common::mojom::DictionaryValueDataView(pointer, context_);
}
inline void MediaParser_ParseMediaMetadata_ResponseParamsDataView::GetAttachedImagesDataView(
    mojo::ArrayDataView<AttachedImageDataView>* output) {
  auto pointer = data_->attached_images.Get();
  *output = mojo::ArrayDataView<AttachedImageDataView>(pointer, context_);
}


inline void MediaParser_CheckMediaFile_ParamsDataView::GetDecodeTimeDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->decode_time.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}
inline void MediaParser_CheckMediaFile_ParamsDataView::GetFileDataView(
    ::mojo_base::mojom::FileDataView* output) {
  auto pointer = data_->file.Get();
  *output = ::mojo_base::mojom::FileDataView(pointer, context_);
}














inline void MediaDataSource_ReadBlob_ResponseParamsDataView::GetDataDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->data.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}



}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_SERVICES_MEDIA_GALLERY_UTIL_PUBLIC_MOJOM_MEDIA_PARSER_MOJOM_SHARED_H_
