// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "headless/lib/headless_render_frame_controller.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "headless/lib/headless_render_frame_controller.mojom-shared-message-ids.h"
#include "mojo/public/cpp/base/big_buffer_mojom_traits.h"
#include "mojo/public/cpp/base/big_string_mojom_traits.h"
namespace headless {
const char HeadlessRenderFrameController::Name_[] = "headless::HeadlessRenderFrameController";

class HeadlessRenderFrameController_InstallTabSocket_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  HeadlessRenderFrameController_InstallTabSocket_ForwardToCallback(
      HeadlessRenderFrameController::InstallTabSocketCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  HeadlessRenderFrameController::InstallTabSocketCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(HeadlessRenderFrameController_InstallTabSocket_ForwardToCallback);
};

class HeadlessRenderFrameController_InstallMainWorldTabSocket_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  HeadlessRenderFrameController_InstallMainWorldTabSocket_ForwardToCallback(
      HeadlessRenderFrameController::InstallMainWorldTabSocketCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  HeadlessRenderFrameController::InstallMainWorldTabSocketCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(HeadlessRenderFrameController_InstallMainWorldTabSocket_ForwardToCallback);
};

HeadlessRenderFrameControllerProxy::HeadlessRenderFrameControllerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void HeadlessRenderFrameControllerProxy::InstallTabSocket(
    int32_t in_v8_execution_context_id, InstallTabSocketCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "headless::HeadlessRenderFrameController::InstallTabSocket");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kHeadlessRenderFrameController_InstallTabSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::headless::internal::HeadlessRenderFrameController_InstallTabSocket_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->v8_execution_context_id = in_v8_execution_context_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new HeadlessRenderFrameController_InstallTabSocket_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void HeadlessRenderFrameControllerProxy::InstallMainWorldTabSocket(
    InstallMainWorldTabSocketCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "headless::HeadlessRenderFrameController::InstallMainWorldTabSocket");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::headless::internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new HeadlessRenderFrameController_InstallMainWorldTabSocket_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void HeadlessRenderFrameControllerProxy::SendMessageToTabSocket(
    const std::string& in_message, int32_t in_v8_execution_context_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "headless::HeadlessRenderFrameController::SendMessageToTabSocket");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kHeadlessRenderFrameController_SendMessageToTabSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::headless::internal::HeadlessRenderFrameController_SendMessageToTabSocket_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->message)::BaseType::BufferWriter
      message_writer;
  mojo::internal::Serialize<::mojo_base::mojom::BigStringDataView>(
      in_message, buffer, &message_writer, &serialization_context);
  params->message.Set(
      message_writer.is_null() ? nullptr : message_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->message.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message in HeadlessRenderFrameController.SendMessageToTabSocket request");
  params->v8_execution_context_id = in_v8_execution_context_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder {
 public:
  static HeadlessRenderFrameController::InstallTabSocketCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder> proxy(
        new HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "HeadlessRenderFrameController::InstallTabSocketCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      bool in_success);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder);
};

bool HeadlessRenderFrameController_InstallTabSocket_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "headless::HeadlessRenderFrameController::InstallTabSocketCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::HeadlessRenderFrameController_InstallTabSocket_ResponseParams_Data* params =
      reinterpret_cast<
          internal::HeadlessRenderFrameController_InstallTabSocket_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  bool p_success{};
  HeadlessRenderFrameController_InstallTabSocket_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_success = input_data_view.success();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "HeadlessRenderFrameController::InstallTabSocket response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_success));
  return true;
}

void HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder::Run(
    bool in_success) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kHeadlessRenderFrameController_InstallTabSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::headless::internal::HeadlessRenderFrameController_InstallTabSocket_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallTabSocketCallback",
               "message", message.name());
#endif
  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder {
 public:
  static HeadlessRenderFrameController::InstallMainWorldTabSocketCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder> proxy(
        new HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "HeadlessRenderFrameController::InstallMainWorldTabSocketCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      int32_t in_v8_execution_context_id);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder);
};

bool HeadlessRenderFrameController_InstallMainWorldTabSocket_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "headless::HeadlessRenderFrameController::InstallMainWorldTabSocketCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_ResponseParams_Data* params =
      reinterpret_cast<
          internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  int32_t p_v8_execution_context_id{};
  HeadlessRenderFrameController_InstallMainWorldTabSocket_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_v8_execution_context_id = input_data_view.v8_execution_context_id();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "HeadlessRenderFrameController::InstallMainWorldTabSocket response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_v8_execution_context_id));
  return true;
}

void HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder::Run(
    int32_t in_v8_execution_context_id) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::headless::internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->v8_execution_context_id = in_v8_execution_context_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallMainWorldTabSocketCallback",
               "message", message.name());
#endif
  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool HeadlessRenderFrameControllerStubDispatch::Accept(
    HeadlessRenderFrameController* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kHeadlessRenderFrameController_InstallTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallTabSocket",
               "message", message->name());
#endif
      break;
    }
    case internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallMainWorldTabSocket",
               "message", message->name());
#endif
      break;
    }
    case internal::kHeadlessRenderFrameController_SendMessageToTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::SendMessageToTabSocket",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::HeadlessRenderFrameController_SendMessageToTabSocket_Params_Data* params =
          reinterpret_cast<internal::HeadlessRenderFrameController_SendMessageToTabSocket_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_message{};
      int32_t p_v8_execution_context_id{};
      HeadlessRenderFrameController_SendMessageToTabSocket_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadMessage(&p_message))
        success = false;
      p_v8_execution_context_id = input_data_view.v8_execution_context_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "HeadlessRenderFrameController::SendMessageToTabSocket deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->SendMessageToTabSocket(
std::move(p_message), 
std::move(p_v8_execution_context_id));
      return true;
    }
  }
  return false;
}

// static
bool HeadlessRenderFrameControllerStubDispatch::AcceptWithResponder(
    HeadlessRenderFrameController* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kHeadlessRenderFrameController_InstallTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallTabSocket",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::HeadlessRenderFrameController_InstallTabSocket_Params_Data* params =
          reinterpret_cast<
              internal::HeadlessRenderFrameController_InstallTabSocket_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_v8_execution_context_id{};
      HeadlessRenderFrameController_InstallTabSocket_ParamsDataView input_data_view(params, &serialization_context);
      
      p_v8_execution_context_id = input_data_view.v8_execution_context_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "HeadlessRenderFrameController::InstallTabSocket deserializer");
        return false;
      }
      HeadlessRenderFrameController::InstallTabSocketCallback callback =
          HeadlessRenderFrameController_InstallTabSocket_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->InstallTabSocket(
std::move(p_v8_execution_context_id), std::move(callback));
      return true;
    }
    case internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::InstallMainWorldTabSocket",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_Params_Data* params =
          reinterpret_cast<
              internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      HeadlessRenderFrameController_InstallMainWorldTabSocket_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "HeadlessRenderFrameController::InstallMainWorldTabSocket deserializer");
        return false;
      }
      HeadlessRenderFrameController::InstallMainWorldTabSocketCallback callback =
          HeadlessRenderFrameController_InstallMainWorldTabSocket_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->InstallMainWorldTabSocket(std::move(callback));
      return true;
    }
    case internal::kHeadlessRenderFrameController_SendMessageToTabSocket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)headless::HeadlessRenderFrameController::SendMessageToTabSocket",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool HeadlessRenderFrameControllerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "HeadlessRenderFrameController RequestValidator");

  switch (message->header()->name) {
    case internal::kHeadlessRenderFrameController_InstallTabSocket_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::HeadlessRenderFrameController_InstallTabSocket_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kHeadlessRenderFrameController_SendMessageToTabSocket_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::HeadlessRenderFrameController_SendMessageToTabSocket_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool HeadlessRenderFrameControllerResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "HeadlessRenderFrameController ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kHeadlessRenderFrameController_InstallTabSocket_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::HeadlessRenderFrameController_InstallTabSocket_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kHeadlessRenderFrameController_InstallMainWorldTabSocket_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::HeadlessRenderFrameController_InstallMainWorldTabSocket_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
void HeadlessRenderFrameControllerInterceptorForTesting::InstallTabSocket(int32_t v8_execution_context_id, InstallTabSocketCallback callback) {
  GetForwardingInterface()->InstallTabSocket(std::move(v8_execution_context_id), std::move(callback));
}
void HeadlessRenderFrameControllerInterceptorForTesting::InstallMainWorldTabSocket(InstallMainWorldTabSocketCallback callback) {
  GetForwardingInterface()->InstallMainWorldTabSocket(std::move(callback));
}
void HeadlessRenderFrameControllerInterceptorForTesting::SendMessageToTabSocket(const std::string& message, int32_t v8_execution_context_id) {
  GetForwardingInterface()->SendMessageToTabSocket(std::move(message), std::move(v8_execution_context_id));
}
HeadlessRenderFrameControllerAsyncWaiter::HeadlessRenderFrameControllerAsyncWaiter(
    HeadlessRenderFrameController* proxy) : proxy_(proxy) {}

HeadlessRenderFrameControllerAsyncWaiter::~HeadlessRenderFrameControllerAsyncWaiter() = default;

void HeadlessRenderFrameControllerAsyncWaiter::InstallTabSocket(
    int32_t v8_execution_context_id, bool* out_success) {
  base::RunLoop loop;
  proxy_->InstallTabSocket(std::move(v8_execution_context_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void HeadlessRenderFrameControllerAsyncWaiter::InstallMainWorldTabSocket(
    int32_t* out_v8_execution_context_id) {
  base::RunLoop loop;
  proxy_->InstallMainWorldTabSocket(
      base::BindOnce(
          [](base::RunLoop* loop,
             int32_t* out_v8_execution_context_id
,
             int32_t v8_execution_context_id) {*out_v8_execution_context_id = std::move(v8_execution_context_id);
            loop->Quit();
          },
          &loop,
          out_v8_execution_context_id));
  loop.Run();
}

}  // namespace headless

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif