// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_INTERNAL_H_
#define HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/big_string.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace headless {
namespace internal {

#pragma pack(push, 1)
class  TabSocket_SendMessageToEmbedder_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TabSocket_SendMessageToEmbedder_Params_Data));
      new (data()) TabSocket_SendMessageToEmbedder_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TabSocket_SendMessageToEmbedder_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TabSocket_SendMessageToEmbedder_Params_Data>(index_);
    }
    TabSocket_SendMessageToEmbedder_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::BigString_Data> message;
  int32_t v8_execution_context_id;
  uint8_t padfinal_[4];

 private:
  TabSocket_SendMessageToEmbedder_Params_Data();
  ~TabSocket_SendMessageToEmbedder_Params_Data() = delete;
};
static_assert(sizeof(TabSocket_SendMessageToEmbedder_Params_Data) == 24,
              "Bad sizeof(TabSocket_SendMessageToEmbedder_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace headless

#endif  // HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_INTERNAL_H_