// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_H_
#define HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "headless/lib/tab_socket.mojom-shared-internal.h"
#include "mojo/public/mojom/base/big_string.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace headless {


}  // namespace headless

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace headless {
// Interface base classes. They are used for type safety check.
class TabSocketInterfaceBase {};

using TabSocketPtrDataView =
    mojo::InterfacePtrDataView<TabSocketInterfaceBase>;
using TabSocketRequestDataView =
    mojo::InterfaceRequestDataView<TabSocketInterfaceBase>;
using TabSocketAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<TabSocketInterfaceBase>;
using TabSocketAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<TabSocketInterfaceBase>;
class TabSocket_SendMessageToEmbedder_ParamsDataView {
 public:
  TabSocket_SendMessageToEmbedder_ParamsDataView() {}

  TabSocket_SendMessageToEmbedder_ParamsDataView(
      internal::TabSocket_SendMessageToEmbedder_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessageDataView(
      ::mojo_base::mojom::BigStringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::BigStringDataView>(
        pointer, output, context_);
  }
  int32_t v8_execution_context_id() const {
    return data_->v8_execution_context_id;
  }
 private:
  internal::TabSocket_SendMessageToEmbedder_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace headless

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace headless {

inline void TabSocket_SendMessageToEmbedder_ParamsDataView::GetMessageDataView(
    ::mojo_base::mojom::BigStringDataView* output) {
  auto pointer = data_->message.Get();
  *output = ::mojo_base::mojom::BigStringDataView(pointer, context_);
}



}  // namespace headless

#endif  // HEADLESS_LIB_TAB_SOCKET_MOJOM_SHARED_H_
