// This file is generated

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "headless/public/devtools/domains/dom_snapshot.h"

#include "base/bind.h"
#include "headless/public/util/error_reporter.h"

namespace headless {

namespace dom_snapshot {

ExperimentalDomain* Domain::GetExperimental() {
  return static_cast<ExperimentalDomain*>(this);
}



void ExperimentalDomain::GetSnapshot(std::unique_ptr<GetSnapshotParams> params, base::OnceCallback<void(std::unique_ptr<GetSnapshotResult>)> callback) {
  dispatcher_->SendMessage("DOMSnapshot.getSnapshot", params->Serialize(), base::BindOnce(&Domain::HandleGetSnapshotResponse, std::move(callback)));
}


// static
void Domain::HandleGetSnapshotResponse(base::OnceCallback<void(std::unique_ptr<GetSnapshotResult>)> callback, const base::Value& response) {
  if (callback.is_null())
    return;
  // This is an error response.
  if (response.is_none()) {
    std::move(callback).Run(nullptr);
    return;
  }
  ErrorReporter errors;
  std::unique_ptr<GetSnapshotResult> result = GetSnapshotResult::Parse(response, &errors);
  DCHECK(!errors.HasErrors()) << errors.ToString();
  std::move(callback).Run(std::move(result));
}

Domain::Domain(internal::MessageDispatcher* dispatcher)
    : dispatcher_(dispatcher) {
}

Domain::~Domain() {}

ExperimentalDomain::ExperimentalDomain(internal::MessageDispatcher* dispatcher)
    : Domain(dispatcher) {}

ExperimentalDomain::~ExperimentalDomain() {}


}  // namespace dom_snapshot

} // namespace headless
