// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "content/common/content_export.h"


namespace blink {
namespace mojom {
class OffscreenCanvasSurfaceClient;
using OffscreenCanvasSurfaceClientPtr = mojo::InterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientRequest = mojo::InterfaceRequest<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurfaceClient>;

class OffscreenCanvasProvider;
using OffscreenCanvasProviderPtr = mojo::InterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderRequest = mojo::InterfaceRequest<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasProvider>;


class OffscreenCanvasSurfaceClientProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceClientStub;

class OffscreenCanvasSurfaceClientRequestValidator;

class CONTENT_EXPORT OffscreenCanvasSurfaceClient
    : public OffscreenCanvasSurfaceClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasSurfaceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceClientStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnFirstSurfaceActivationMinVersion = 0,
  };
  virtual ~OffscreenCanvasSurfaceClient() {}

  virtual void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) = 0;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientInterceptorForTesting : public OffscreenCanvasSurfaceClient {
  virtual OffscreenCanvasSurfaceClient* GetForwardingInterface() = 0;
  void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) override;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientAsyncWaiter {
 public:
  explicit OffscreenCanvasSurfaceClientAsyncWaiter(OffscreenCanvasSurfaceClient* proxy);
  ~OffscreenCanvasSurfaceClientAsyncWaiter();

 private:
  OffscreenCanvasSurfaceClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurfaceClientAsyncWaiter);
};

class OffscreenCanvasProviderProxy;

template <typename ImplRefTraits>
class OffscreenCanvasProviderStub;

class OffscreenCanvasProviderRequestValidator;

class CONTENT_EXPORT OffscreenCanvasProvider
    : public OffscreenCanvasProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasProviderStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasProviderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateOffscreenCanvasSurfaceMinVersion = 0,
    kCreateCompositorFrameSinkMinVersion = 0,
  };
  virtual ~OffscreenCanvasProvider() {}

  virtual void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client) = 0;

  virtual void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::CompositorFrameSinkClientPtr client, ::viz::mojom::CompositorFrameSinkRequest sink) = 0;
};
class CONTENT_EXPORT OffscreenCanvasProviderInterceptorForTesting : public OffscreenCanvasProvider {
  virtual OffscreenCanvasProvider* GetForwardingInterface() = 0;
  void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client) override;
  void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::CompositorFrameSinkClientPtr client, ::viz::mojom::CompositorFrameSinkRequest sink) override;
};
class CONTENT_EXPORT OffscreenCanvasProviderAsyncWaiter {
 public:
  explicit OffscreenCanvasProviderAsyncWaiter(OffscreenCanvasProvider* proxy);
  ~OffscreenCanvasProviderAsyncWaiter();

 private:
  OffscreenCanvasProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasProviderAsyncWaiter);
};

class CONTENT_EXPORT OffscreenCanvasSurfaceClientProxy
    : public OffscreenCanvasSurfaceClient {
 public:
  explicit OffscreenCanvasSurfaceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class CONTENT_EXPORT OffscreenCanvasProviderProxy
    : public OffscreenCanvasProvider {
 public:
  explicit OffscreenCanvasProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client) final;
  void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::CompositorFrameSinkClientPtr client, ::viz::mojom::CompositorFrameSinkRequest sink) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurfaceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasSurfaceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurfaceClient>>
class OffscreenCanvasSurfaceClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceClientStub() {}
  ~OffscreenCanvasSurfaceClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT OffscreenCanvasProviderStubDispatch {
 public:
  static bool Accept(OffscreenCanvasProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasProvider>>
class OffscreenCanvasProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasProviderStub() {}
  ~OffscreenCanvasProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class CONTENT_EXPORT OffscreenCanvasSurfaceClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class CONTENT_EXPORT OffscreenCanvasProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_H_